/*
 * tvprogxml
 * Copyright (c) 2003       Erik Waling <erikw@acc.umu.se>
 * Distributed under the terms of the GNU GPL. See the COPYING file
 * for a copy of the GNU Genereal Public License.
 */

#include "main.h"

void check_watches(struct channel *c) {

    time_t t = time(NULL);
    time_t diff;
    struct content *cp;

    while (c) {
        cp = c->content;
        while (c->content) {
            if (c->content->watch) {
                diff = c->content->start_time - t;
                if ((diff <= (conf.alarm_minutes * 60)) && (diff >= 0) && !c->content->done_alarm) {
                    c->content->done_alarm = 1;
                    do_alarm(c->content, c->channel_name);
                }
            }
            c->content = c->content->next;
        }
        c->content = cp;
        c = c->next;
    }
}

void do_alarm(struct content *cp, char *channel) {

    char *execstr;
    char begin[6], end[6];
    struct tm *tim;
    
    if (!conf.extalarm) {
        beep();
    }
    else {
        execstr = strdup(conf.extalarm);
        tim = localtime(&cp->start_time);
        sprintf(begin, "%.2d:%.2d", tim->tm_hour, tim->tm_min);
        tim = localtime(&cp->end_time);
        sprintf(end, "%.2d:%.2d", tim->tm_hour, tim->tm_min);
        execstr = replace_str_token(getenv("HOME"), "~", execstr, 0);
        execstr = replace_str_token(channel, "#channel", execstr, 0);
        execstr = replace_str_token(cp->title, "#title", execstr, 0);
        execstr = replace_str_token(cp->desc, "#description", execstr, 0);
        execstr = replace_str_token(begin, "#begin_time", execstr, 0);
        execstr = replace_str_token(end, "#end_time", execstr, 0);
        execstr = replace_str_token(cp->showview, "#showview", execstr, 0);
        
        /* FIXME: fork()! */
        system(execstr); 


    }
    return;
}

    
