/*
 * tvprogxml
 * Copyright (c) 2003       Erik Waling <erikw@acc.umu.se>
 * Distributed under the terms of the GNU GPL. See the COPYING file
 * for a copy of the GNU Genereal Public License.
 */

#include "main.h"

int main(void) {

    time_t t;
    struct tm *tim;
    int ret;
    chan = NULL;
    
    printf("tvprogxml v%s\n", VERSION);
    cfg_set_default();
    cfg_read(&conf);
    cfg_read_watch(&conf);
    cfg_check_config();
    read_xmltv_data(conf.xmltv_file);
    cfg_read_sortorder(chan);
    chan = sort_channels(chan);
    flag_watches(chan);
    /*
    debug_chan_print(chan);
    debug_funct(chan);
    exit(0);
    */
    init_curses();
    get_channels(chan); 
    
    while (1) {
        t = time(NULL);
        tim = localtime(&t);
        if (tim->tm_sec == 0) {
            /* every minute */
            if (tim->tm_min == 0) {
                /* every hour */
                free_old_programs(chan);
                if (tim->tm_hour == conf.reload_hour) {
                    read_xmltv_data(conf.xmltv_file);
                    cfg_read_watch(&conf);
                    flag_watches(chan);
                }
            }
            get_programs(chan);
            check_watches(chan);

        }
        if ((ret = getch()) != ERR) {
            switch (ret) {
                case 113: /* q */
                    kill_curses();
                    exit(EXIT_SUCCESS);
                    break;
                case 114: /* r */
                    cfg_read_watch(&conf);
                    flag_watches(chan);
                    get_programs(chan);
                    break;
#if 0                
                case 102: /* f */
                    find_program(chan);
                    break;
                case 111: /* o */
                    read_xmltv_data(conf.xmltv_file);
                    get_programs(chan);
                    break;
                case 112: /* p */
                    free_old_programs(chan);
                    get_programs(chan);
                    break;
#endif                 
                
            }

        }
        
    }

    return 0;
}

